unit fMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, MMSystem, uGrid, Grids, StdCtrls;

type
  TfrmMain = class(TForm)
    timerGo: TTimer;
    gbSettings: TGroupBox;
    butGo: TButton;
    grdSettings: TStringGrid;
    procedure timerGoTimer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure butGoClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
      FbmOffs : TBitmap;
      FWaitSync, FTerminated : Boolean;
      FGrid : TGrid;
      procedure PaintBlobs;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.PaintBlobs;
var
    I : Integer;
begin
    FGrid.Render( FbmOffs.Canvas );
//    StretchBlt( Canvas.Handle, 0,0, ClientWidth, ClientHeight,
//            FbmOffs.Canvas.Handle, 0,0, kMaxX, kMaxY, SRCCOPY );
    BitBlt( Canvas.Handle, 0,0, ClientWidth, ClientHeight,
            FbmOffs.Canvas.Handle, 0,0, SRCCOPY );
end;

procedure TfrmMain.timerGoTimer(Sender: TObject);
var
    I : Integer;
    time, Start : Integer;
    Freq, SyncTime, Generations : Integer;
    hdc : THandle;
begin
    timerGo.Enabled := False;
    Generations := 0;
    Start := GetTickCount;
    SyncTime := timeGetTime;

    ClientWidth := kMaxX;
    ClientHeight := kMaxY;
    FbmOffs := TBitmap.Create;
    FbmOffs.Width := ClientWidth;
    FbmOffs.Height := ClientHeight;
    FGrid := TGrid.Create;

    hdc := GetDC(0);
    freq := GetDeviceCaps(hdc, VREFRESH);
    ReleaseDC(0, hdc);

//    Freq := 10;
    freq := 1000 div freq;

    while not FTerminated do begin
        Inc(Generations);
        FGrid.Step;

        PaintBlobs;
        SyncTime := timeGetTime - SyncTime;
        SyncTime := SyncTime mod freq;

        SyncTime := timeGetTime;
        Application.ProcessMessages;
    end;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    FTerminated := True;
end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    FWaitSync := not FWaitSync;
end;

procedure TfrmMain.butGoClick(Sender: TObject);
var
    I : Integer;
begin
    for I := 0 to High( vModels) do begin
        vModels[I].Redux := StrToFloat(grdSettings.Cells[1,I+1]);
        vModels[I].InitCount := StrToInt(grdSettings.Cells[2,I+1]);
    end;
    gbSettings.Visible := False;
    timerGo.Enabled := True;
end;

var
   bShowFirst : Boolean = True;

procedure TfrmMain.FormShow(Sender: TObject);
var
    Grd : TStringGrid;
    I : Integer;

begin
    if not bShowFirst then Exit;
    bShowFirst := True;
    Grd := grdSettings;
    Grd.Cells[0,0] := 'Symbol';
    Grd.Cells[1,0] := 'Redux';
    Grd.Cells[2,0] := 'Number';

    Grd.RowCount := High( vModels )+2;
    for I := 0 to High( vModels) do begin
        Grd.Cells[0,I+1] := vModels[I].Symbol;
        Grd.Cells[1,I+1] := Copy(FloatToStr(vModels[I].Redux),1,6);
        Grd.Cells[2,I+1] := IntToStr(vModels[I].InitCount);
    end;

end;

end.
